<?php

namespace dgsoft\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LCCParameters StructType
 * @package Dg
 * @subpackage Structs
 */
class DgLCCParameters extends AbstractStructBase
{
    /**
     * The IsSpeedyBoarding
     * @var bool
     */
    public $IsSpeedyBoarding;
    /**
     * The IsOnlineCheckIn
     * @var bool
     */
    public $IsOnlineCheckIn;
    /**
     * The CheckInOption
     * @var string
     */
    public $CheckInOption;
    /**
     * The CheckInOption1
     * @var string
     */
    public $CheckInOption1;
    /**
     * Constructor method for LCCParameters
     * @uses DgLCCParameters::setIsSpeedyBoarding()
     * @uses DgLCCParameters::setIsOnlineCheckIn()
     * @uses DgLCCParameters::setCheckInOption()
     * @uses DgLCCParameters::setCheckInOption1()
     * @param bool $isSpeedyBoarding
     * @param bool $isOnlineCheckIn
     * @param string $checkInOption
     * @param string $checkInOption1
     */
    public function __construct($isSpeedyBoarding = null, $isOnlineCheckIn = null, $checkInOption = null, $checkInOption1 = null)
    {
        $this
            ->setIsSpeedyBoarding($isSpeedyBoarding)
            ->setIsOnlineCheckIn($isOnlineCheckIn)
            ->setCheckInOption($checkInOption)
            ->setCheckInOption1($checkInOption1);
    }
    /**
     * Get IsSpeedyBoarding value
     * @return bool|null
     */
    public function getIsSpeedyBoarding()
    {
        return $this->IsSpeedyBoarding;
    }
    /**
     * Set IsSpeedyBoarding value
     * @param bool $isSpeedyBoarding
     * @return \dgsoft\StructType\DgLCCParameters
     */
    public function setIsSpeedyBoarding($isSpeedyBoarding = null)
    {
        // validation for constraint: boolean
        if (!is_null($isSpeedyBoarding) && !is_bool($isSpeedyBoarding)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($isSpeedyBoarding)), __LINE__);
        }
        $this->IsSpeedyBoarding = $isSpeedyBoarding;
        return $this;
    }
    /**
     * Get IsOnlineCheckIn value
     * @return bool|null
     */
    public function getIsOnlineCheckIn()
    {
        return $this->IsOnlineCheckIn;
    }
    /**
     * Set IsOnlineCheckIn value
     * @param bool $isOnlineCheckIn
     * @return \dgsoft\StructType\DgLCCParameters
     */
    public function setIsOnlineCheckIn($isOnlineCheckIn = null)
    {
        // validation for constraint: boolean
        if (!is_null($isOnlineCheckIn) && !is_bool($isOnlineCheckIn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($isOnlineCheckIn)), __LINE__);
        }
        $this->IsOnlineCheckIn = $isOnlineCheckIn;
        return $this;
    }
    /**
     * Get CheckInOption value
     * @return string|null
     */
    public function getCheckInOption()
    {
        return $this->CheckInOption;
    }
    /**
     * Set CheckInOption value
     * @param string $checkInOption
     * @return \dgsoft\StructType\DgLCCParameters
     */
    public function setCheckInOption($checkInOption = null)
    {
        // validation for constraint: string
        if (!is_null($checkInOption) && !is_string($checkInOption)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($checkInOption)), __LINE__);
        }
        $this->CheckInOption = $checkInOption;
        return $this;
    }
    /**
     * Get CheckInOption1 value
     * @return string|null
     */
    public function getCheckInOption1()
    {
        return $this->CheckInOption1;
    }
    /**
     * Set CheckInOption1 value
     * @param string $checkInOption1
     * @return \dgsoft\StructType\DgLCCParameters
     */
    public function setCheckInOption1($checkInOption1 = null)
    {
        // validation for constraint: string
        if (!is_null($checkInOption1) && !is_string($checkInOption1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($checkInOption1)), __LINE__);
        }
        $this->CheckInOption1 = $checkInOption1;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\StructType\DgLCCParameters
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
